<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/filterelements.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>filterelements.c</h1><a href="filterelements_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: filterelements.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="filterelements_8c.html#a186b8075211f880eab30e33434e511a9">00029</a> <span class="preprocessor">#define C_DEL -5   </span>
<a name="l00031"></a><a class="code" href="init_8h.html#a49c370a78a03718555d9d871ef6e11ee">00031</a> <span class="preprocessor">int FilterElements(int *pn_ele,int **pelevert,int **peleprop,PetscReal *propdat)</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>{
<a name="l00033"></a>00033   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   <span class="keywordtype">int</span> rank,size;
<a name="l00036"></a>00036   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00037"></a>00037   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="keywordflow">if</span> (rank) {
<a name="l00040"></a>00040     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00041"></a>00041   }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   <span class="keywordtype">int</span> n_ele;    n_ele=*pn_ele;
<a name="l00044"></a>00044   <span class="keywordtype">int</span> *elevert; elevert=*pelevert;
<a name="l00045"></a>00045   <span class="keywordtype">int</span> *eleprop; eleprop=*peleprop;
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="keywordtype">int</span> n_del=0;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="comment">/* get number of elements to be deleted, delete element if Js&lt;0 */</span>
<a name="l00050"></a>00050   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_ele;i++) {
<a name="l00051"></a>00051     <span class="keywordflow">if</span> (propdat[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*eleprop[i]+4]&lt;0.0) {
<a name="l00052"></a>00052       eleprop[i]=-1;
<a name="l00053"></a>00053       n_del++;
<a name="l00054"></a>00054     }
<a name="l00055"></a>00055   }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="keywordflow">if</span> (n_del&gt;0) {
<a name="l00058"></a>00058     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00059"></a>00059     <span class="stringliteral">&quot;Removing elements: %i out of %i\n&quot;</span>,n_del,n_ele);
<a name="l00060"></a>00060   }
<a name="l00061"></a>00061   <span class="keywordflow">else</span> {
<a name="l00062"></a>00062     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;No elements to be removed\n&quot;</span>);
<a name="l00063"></a>00063     <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00064"></a>00064   }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Allocating new element arrays\n&quot;</span>);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="comment">/* allocate new array for elements */</span>
<a name="l00070"></a>00070   <span class="keywordtype">int</span> *televert;
<a name="l00071"></a>00071   ierr = PetscMalloc(<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>*(n_ele-n_del)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;televert);CHKERRQ(ierr);
<a name="l00072"></a>00072   <span class="keywordtype">int</span> *teleprop;
<a name="l00073"></a>00073   ierr = PetscMalloc((n_ele-n_del)*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;teleprop);CHKERRQ(ierr);
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Copying element data\n&quot;</span>);
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="comment">/* copy elements and properties */</span>
<a name="l00078"></a>00078   <span class="keywordtype">int</span> k=0;
<a name="l00079"></a>00079   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_ele;i++) {
<a name="l00080"></a>00080     <span class="keywordflow">if</span> (eleprop[i]&gt;=0) {
<a name="l00081"></a>00081       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;<a class="code" href="griddata_8h.html#af7b1400a617718754e5de5c255467af5">NV</a>;j++) {
<a name="l00082"></a>00082         televert[NV*k+j]=elevert[NV*i+j];
<a name="l00083"></a>00083       }
<a name="l00084"></a>00084       teleprop[k]=eleprop[i];
<a name="l00085"></a>00085       k++;
<a name="l00086"></a>00086     }
<a name="l00087"></a>00087   }
<a name="l00088"></a>00088   assert(k==n_ele-n_del);
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   n_ele -= n_del;
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="comment">/* update counters */</span>
<a name="l00093"></a>00093   *pn_ele=n_ele;
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   ierr = PetscFree(*pelevert);CHKERRQ(ierr);
<a name="l00096"></a>00096   *pelevert=televert;
<a name="l00097"></a>00097   ierr = PetscFree(*peleprop);CHKERRQ(ierr);
<a name="l00098"></a>00098   *peleprop=teleprop;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00101"></a>00101 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

